const express = require('express');
const app = express();

app.get('/', (req, res) => {
  const Vue = require('vue');
  const app = new Vue({
    template: '<div>Hello! {{ name }}</div>',
    data: { name: 'WEB+DB PRESS' },
    created() {
      console.log('created');
    },
    mounted() {
      console.log('mounted');
    }
  });

  const renderer = require('vue-server-renderer').createRenderer();

  renderer.renderToString(app, (err, html) => {
    if (err) throw err;

    res.send(`
    <html>
      <head></head>
      <body>
        <div id="app">
          ${html}
        </div>
      </body>
      <script src="https://unpkg.com/vue"></script>
      <script>
        const app = new Vue({
          template: '<div>Hello! {{ name }}</div>',
          data: { name: 'WEB+DB PRESS' },
          created() {
            console.log('created');
          },
          mounted() {
            console.log('mounted');
          }
        });
        
        app.$mount('#app');
      </script>
    </html>
    `);
  });
});

app.listen(3000); // http://localhost:3000で確認
